---
title: WP Interactive Prover
author:
date: 2024-12-05
...

# WP Interactive Prover {#wp-interactive-prover}

## plugins.wp.tip.proofStatus (`SIGNAL`) {#proofstatus}

Proof Status has changed


## plugins.wp.tip.printStatus (`SIGNAL`) {#printstatus}

Updated TIP printer


## plugins.wp.tip.node (`DATA`) {#node}

Proof Node index


> [`node`](#node)  `::=` `#node`
  

## plugins.wp.tip.tactic (`DATA`) {#tactic}

Tactic identifier


> [`tactic`](#tactic)  `::=` `$tactic`
  

## plugins.wp.tip.getNodeInfos (`GET`) {#getnodeinfos}

Proof node information


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"title"` | _string_ | Proof node title |
| `"proved"` | _boolean_ | Proof node complete |
| `"pending"` | _number_ | Pending children |
| `"size"` | _number_ | Proof size |
| `"stats"` | _string_ | Node statistics |
| `"results"` | `[` [`prover`](index.md#prover)  , [`result`](index.md#result)  `]` `[]` | Prover results for current node |
| `"tactic"` (opt.) | [`tactic`](tip.md#tactic)  | Applied tactic (if any) |
| `"header"` (opt.) | _string_ | Proof node tactic label (if any) |
| `"childLabel"` (opt.) | _string_ | Proof node child label (from parent, if any) |
| `"path"` | [`node`](tip.md#node)  `[]` | Proof node path from goal |
| `"children"` | [`node`](tip.md#node)  `[]` | Proof node tactic children (id any) |


> _signals_
  

* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.getResult (`GET`) {#getresult}

Result for specified node and prover


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` [`result`](index.md#result) 
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | [`node`](tip.md#node)  | Proof node |
| `"prover"` | [`prover`](index.md#prover)  | Prover |


> _signals_
  

* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.getProofStatus (`GET`) {#getproofstatus}

Current Proof Status of a Goal


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` `{` _output…_ `}`
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"main"` | [`goal`](index.md#goal)  | Proof Obligation |
| `"unproved"` (opt.) | _boolean_ | Report unproved children only |
| `"subtree"` (opt.) | _boolean_ | Report subtree children only |


| Output | Format | Description |
|:-------|:------:|:------------|
| `"size"` | _number_ | Proof size |
| `"index"` | _number_ | Current node index among pending nodes (else -1) |
| `"pending"` | _number_ | Pending proof nodes |
| `"current"` | [`node`](tip.md#node)  | Current proof node |
| `"parents"` | [`node`](tip.md#node)  `[]` | parents nodes |
| `"tactic"` (opt.) | [`tactic`](tip.md#tactic)  | Applied tactic (if any) |
| `"children"` | [`node`](tip.md#node)  `[]` | Children nodes |


> _signals_
  

* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.goForward (`SET`) {#goforward}

Go to to first pending node, or root if none


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.goToRoot (`SET`) {#gotoroot}

Go to root of proof tree


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.goToIndex (`SET`) {#gotoindex}

Go to k-th pending node of proof tree


> _input_ `::=` `[` [`goal`](index.md#goal)  , _number_ `]`
  

> _output_ `::=` _null_
  

## plugins.wp.tip.goToNode (`SET`) {#gotonode}

Set current node of associated proof tree


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.clearNode (`SET`) {#clearnode}

Cancel all node results and sub-tree (if any)


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.clearNodeTactic (`SET`) {#clearnodetactic}

Cancel node current tactic


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.clearParentTactic (`SET`) {#clearparenttactic}

Cancel parent node tactic


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.clearGoal (`SET`) {#cleargoal}

Remove the complete goal proof tree


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.part (`DATA`) {#part}

Proof part marker


> [`part`](#part)  `::=` `$part`
  

## plugins.wp.tip.term (`DATA`) {#term}

Term marker


> [`term`](#term)  `::=` `$term`
  

## plugins.wp.tip.iformat (`DATA`) {#iformat}

Integer constants format


> [`iformat`](#iformat)  `::=` `"dec"` | `"hex"` | `"bin"`
  

## plugins.wp.tip.rformat (`DATA`) {#rformat}

Real constants format


> [`rformat`](#rformat)  `::=` `"ratio"` | `"float"` | `"double"`
  

## plugins.wp.tip.printSequent (`GET`) {#printsequent}

Pretty-print the associated node


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` [`text`](../../kernel/data.md#text) 
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` (opt.) | [`node`](tip.md#node)  | Proof Node |
| `"indent"` (opt.) | _number_ | Number of identation spaces |
| `"margin"` (opt.) | _number_ | Maximial text width |
| `"iformat"` (opt.) | [`iformat`](tip.md#iformat)  | Integer constants format |
| `"rformat"` (opt.) | [`rformat`](tip.md#rformat)  | Real constants format |
| `"autofocus"` (opt.) | _boolean_ | Auto-focus mode |
| `"unmangled"` (opt.) | _boolean_ | Unmangled memory model |


> _signals_
  

* `plugins.wp.tip.printStatus`


## plugins.wp.tip.clearSelection (`SET`) {#clearselection}

Reset node selection


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.setSelection (`SET`) {#setselection}

Set node selection


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` _null_
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | [`node`](tip.md#node)  | Proof Node |
| `"part"` (opt.) | [`part`](tip.md#part)  | Selected part |
| `"term"` (opt.) | [`term`](tip.md#term)  | Selected term |
| `"extend"` (opt.) | _boolean_ | Extending selection mode |


## plugins.wp.tip.getSelection (`GET`) {#getselection}

Get current selection in proof node


> _input_ `::=` [`node`](tip.md#node) 
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"part"` (opt.) | [`part`](tip.md#part)  | Selected part |
| `"term"` (opt.) | [`term`](tip.md#term)  | Selected term |


> _signals_
  

* `plugins.wp.tip.printStatus`
* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.runProvers (`SET`) {#runprovers}

Schedule provers on proof node


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` _null_
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | [`node`](tip.md#node)  | Proof node |
| `"timeout"` (opt.) | _number_ | Prover timeout (in seconds, default: current) |
| `"provers"` (opt.) | [`prover`](index.md#prover)  `[]` | Prover selection (default: current |


## plugins.wp.tip.killProvers (`SET`) {#killprovers}

Interrupt running provers on proof node


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` _null_
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | [`node`](tip.md#node)  | Proof node |
| `"provers"` (opt.) | [`prover`](index.md#prover)  `[]` | Prover selection (default: all running provers |


## plugins.wp.tip.clearProvers (`SET`) {#clearprovers}

Remove prover results from proof node


> _input_ `::=` `{` _input…_ `}`
  

> _output_ `::=` _null_
  

| Input | Format | Description |
|:------|:------:|:------------|
| `"node"` | [`node`](tip.md#node)  | Proof node |
| `"provers"` (opt.) | [`prover`](index.md#prover)  `[]` | Prover selection (default: all results |


## plugins.wp.tip.getScriptStatus (`GET`) {#getscriptstatus}

Script Status for a given Goal


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` `{` _output…_ `}`
  

| Output | Format | Description |
|:-------|:------:|:------------|
| `"proof"` | _boolean_ | Some Proof Tree can be Saved |
| `"script"` (opt.) | _string_ | Script File (if any) |
| `"saved"` | _boolean_ | Current Proof Script has been Saved |


> _signals_
  

* `plugins.wp.tip.proofStatus`


## plugins.wp.tip.saveScript (`SET`) {#savescript}

Save Script for the Goal


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.runScript (`SET`) {#runscript}

Replay Saved Script for the Goal (if any)


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  

## plugins.wp.tip.clearProofScript (`SET`) {#clearproofscript}

Clear Proof and Remove any Saved Script for the Goal


> _input_ `::=` [`goal`](index.md#goal) 
  

> _output_ `::=` _null_
  